package com.example.myapplication;


import static com.ctYun.sdk.init.IdealSplash.getMobileAuthToken;

import androidx.appcompat.app.AppCompatActivity;

import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.util.Log;
import android.view.View;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;


import com.ctYun.sdk.backInterface.MobileAuthCallback;
import com.ctYun.sdk.net.Request;
import com.ctYun.sdk.net.RequestListener;


import org.json.JSONException;
import org.json.JSONObject;

import java.util.HashMap;

public class LocalCalibration extends AppCompatActivity {
    private EditText localPhone;
    private LinearLayout back;
    private TextView authentication;

    public static MobileAuthCallback mobileAuthCallback;
    //号码认证接口
    private String authUrl = "http://101.43.28.137:9300/appServer/verifyMobile";
    private boolean isButtonClicked = false;
    private TextView t1, t2;
    private LinearLayout verifyEditText, ed_ly;
    public static String number;
    public static String txt1;
    public static String txt2;
    public static String phoneNumber;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        capabilities.StatusBar(LocalCalibration.this);

        setContentView(R.layout.activity_local_calibration);
        back = findViewById(R.id.back);
        authentication = findViewById(R.id.authentication);
        localPhone = findViewById(R.id.phone);
        verifyEditText = findViewById(R.id.v);
        ed_ly = findViewById(R.id.ed_ly);
        t1 = findViewById(R.id.t1);
        t2 = findViewById(R.id.t2);


        SharedPreferences sp = PreferenceManager.getDefaultSharedPreferences(LocalCalibration.this);
        phoneNumber = sp.getString("number", "null");
        if (phoneNumber.equals("null")) {
            verifyEditText.setVisibility(View.GONE);
            ed_ly.setVisibility(View.VISIBLE);
            authentication.setVisibility(View.VISIBLE);
        } else {
            verifyEditText.setVisibility(View.VISIBLE);
            authentication.setVisibility(View.GONE);
            ed_ly.setVisibility(View.GONE);
            number = phoneNumber.substring(3, 7);
            t1.setText(phoneNumber.substring(0, 3));
            t2.setText(phoneNumber.substring(7, 11));
            txt1 = t1.getText().toString();
            txt2 = t2.getText().toString();
        }


        getWindow().setStatusBarColor(getColor(R.color.white));
        getWindow().getDecorView().setSystemUiVisibility(View.SYSTEM_UI_FLAG_LIGHT_STATUS_BAR);
        back.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();
            }
        });
        //获取本机号码校验 token
        authentication.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (!isButtonClicked) {
                    // 执行按钮点击事件
                    isButtonClicked = true;
                    getMobileAuthToken(LocalCalibration.this, localPhone.getText().toString(), mobileAuthCallback, 5);
                }
            }
        });
        //获取token回调
        mobileAuthCallback = new MobileAuthCallback() {
            @Override
            public void onResult(String result) {
                try {
                    Log.i("Demo_", "校验获取token" + result.toString());
                    JSONObject obj = new JSONObject(result);
                    String resultCode = obj.optString("resultCode");
                    //0 调用成功
                    if (resultCode.equals("0")) {
                        String token = obj.optString("token");
                        //请求客户服务器 开始认证
                        getAuth(token);
                    } else {
                        Toast.makeText(LocalCalibration.this, "错误信息：" + result, Toast.LENGTH_SHORT).show();
                    }
                } catch (JSONException e) {
                    e.printStackTrace();
                }
            }
        };
    }

    //请求认证接口 需要传入 appid  userid token
    public void getAuth(String token) {
        HashMap<String, String> parmHashMap = new HashMap<>();
        parmHashMap.put("userId", MainActivity.initUserId);
        parmHashMap.put("appId", MainActivity.app_Id);
        parmHashMap.put("token", token);
        HashMap hashMap = new HashMap();
        //请求头部
        hashMap.put("Content-Type", "application/json;charset=UTF-8");
        Request.getInstance().Http(LocalCalibration.this, authUrl, parmHashMap, hashMap, new RequestListener() {
            @Override
            public void onComplete(String response) {
                Log.i("Demo_phone", "校验结果response" + response.toString());
                try {
                    JSONObject obj = new JSONObject(response);
                    String resultCode = obj.optString("code");
                    Intent intent = new Intent(LocalCalibration.this, VerifyResultActivity.class);
                    intent.putExtra("resCode", resultCode);
                    intent.putExtra("resMsg", response);
                    intent.putExtra("resType", "2");
                    startActivity(intent);
                    isButtonClicked = false;
                } catch (JSONException e) {
                    e.printStackTrace();
                }
            }
        });
    }

}