package com.example.myapplication;


import static com.ctYun.sdk.init.IdealSplash.getToken;
import static com.ctYun.sdk.init.IdealSplash.preLogin;


import androidx.appcompat.app.AppCompatActivity;

import android.app.AlertDialog;
import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Color;
import android.graphics.Point;
import android.graphics.Typeface;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
import android.preference.PreferenceManager;
import android.text.method.LinkMovementMethod;
import android.util.Log;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;

import android.view.Window;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;


import com.cmic.gen.sdk.view.AuthLoginCallBack;
import com.ctYun.sdk.backInterface.AuthLoginBtCallBack;
import com.ctYun.sdk.backInterface.AuthLoginListener;
import com.ctYun.sdk.backInterface.AuthThemListener;
import com.ctYun.sdk.backInterface.BackPressedListener;
import com.ctYun.sdk.backInterface.CustomCallback;
import com.ctYun.sdk.backInterface.initCallBack;
import com.ctYun.sdk.backInterface.initCallOnClick;
import com.ctYun.sdk.init.IdealSplash;
import com.ctYun.sdk.net.Request;
import com.ctYun.sdk.net.RequestListener;
import com.ctYun.sdk.themeconfig.OnenessAuthThemeConfig;
import com.ctYun.sdk.themeconfig.OnenessAuthThemeDialogConfig;


import org.json.JSONException;
import org.json.JSONObject;

import java.util.HashMap;
import java.util.Map;


public class MainActivity extends AppCompatActivity implements View.OnClickListener {
    //应用id
    public static String app_Id = "20211216163728407";
    public static String appSecret = "15f61379d5cd53bfa836e913cf93caea";
    //客户服务器取号地址
    private String getPhone_Url = "http://101.43.28.137:9300/appServer/getMobilePhoneProductionV2";
    private CustomCallback customCallback;
    //是否为弹窗
    private Boolean isDialog;
    private Boolean isBottomDialog;
    private TextView login_page;
    private TextView login_dialog_page;
    private TextView login_bottom_dialog_page;
    private TextView local_calibration;
    private String msg;
    //用户userId
    public static String initUserId;
    private String TAG = "Demo_";
    private Context context;
    Dialog alertDialog;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        capabilities.StatusBar(MainActivity.this);
        context = MainActivity.this;

        login_dialog_page = findViewById(R.id.login_dialog_page);
        local_calibration = findViewById(R.id.local_calibration);
        login_bottom_dialog_page = findViewById(R.id.login_bottom_dialog_page);
        login_page = findViewById(R.id.login_page);
        login_page.setOnClickListener(this);
        login_dialog_page.setOnClickListener(this);
        local_calibration.setOnClickListener(this);
        login_bottom_dialog_page.setOnClickListener(this);

        if (IsRoot.isSuEnable()) {
            Toast.makeText(context, "不支持root设备", Toast.LENGTH_SHORT).show();
        } else {
            //第一步：初始化：如果放在onCreate里初始化 建议加handle
            Handler handler = new Handler(Looper.getMainLooper());
            handler.post(new Runnable() {
                @Override
                public void run() {
                    IdealSplash.initSdk(MainActivity.this, app_Id, appSecret);
                    SharedPreferences sp2 = PreferenceManager.getDefaultSharedPreferences(context);
                    SharedPreferences.Editor editor = sp2.edit();
                    editor.putString("number", null);
                    editor.apply();
                }
            });
        }

        customCallback = new CustomCallback() {
            @Override
            public void onResult(String result) {
                try {
                    JSONObject obj = new JSONObject(result);
                    Log.i(TAG, "预登录结果" + result);
                    String resultCode = obj.optString("resultCode");
//                    IdealSplash.clearLoginCache(context);
                    //0  调用成功
                    if (resultCode != null && resultCode.equals("0")) {
                        if (!obj.has("token")) {
                            //全屏页面false，弹窗页面true
                            if (!isDialog) {
                                getToken(context, onenessConfig(), customCallback, 5);
                            } else if (isDialog) {
                                getToken(context, onenessDialogConfig(), customCallback, 5);
                            }
                        } else if (obj.has("token")) {//加密token
                            String token = obj.optString("token");
                            getNumber(token);
                        }
                    } else {
                        Handler handler = new Handler(Looper.getMainLooper());
                        handler.post(new Runnable() {
                            @Override
                            public void run() {
                                Toast.makeText(context, "" + result, Toast.LENGTH_SHORT).show();
                            }
                        });
                    }
                } catch (JSONException e) {
                    e.printStackTrace();
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        };
        initCallBack();
        //其他能力接口
        capabilities.CustomMethod(MainActivity.this);
    }

    //取号
    private void getNumber(String token) {
        // 注意： 取号请求时需要对 需要传入的参数 进行判空 ，避免有参数错误请求失败
        HashMap<String, String> parmHashMap = new HashMap<>();
        parmHashMap.put("token", token);
        parmHashMap.put("userId", initUserId);
        parmHashMap.put("appId", app_Id);
        HashMap hashMap = new HashMap();
        //请求头部
        hashMap.put("Content-Type", "application/json;charset=UTF-8");
        // 取号请求
        Request.getInstance().Http(context, getPhone_Url, parmHashMap, hashMap, new RequestListener() {
            @Override
            public void onComplete(String response) {
                try {
                    Log.i(TAG, "token" + token);

                    Log.i(TAG, "取号结果" + response);
                    JSONObject responseObj = new JSONObject(response);
                    String code = responseObj.optString("code");
                    Intent intent = new Intent(context, VerifyResultActivity.class);
                    intent.putExtra("resCode", code);
                    intent.putExtra("resMsg", response);
                    intent.putExtra("resType", "1");
                    startActivity(intent);
//                    if (alertDialog != null && alertDialog.isShowing()) {
//                        alertDialog.dismiss();
//                        alertDialog = null;
//                    }
                } catch (JSONException e) {
                    e.printStackTrace();
                }
                //关闭授权页
                Handler handler = new Handler(Looper.getMainLooper());
                handler.post(new Runnable() {
                    @Override
                    public void run() {
                        IdealSplash.quitAuthPage(context);
                    }
                });
            }
        });
    }

    //全屏
    private OnenessAuthThemeConfig onenessConfig() {
        OnenessAuthThemeConfig.Builder builder = new OnenessAuthThemeConfig.Builder().setAuthBGImgPath("onenessconfig_bg")
                //在背景是图片时要拉伸到状态栏 设置为true。不设置为false
                .setIsImmersive(false)
                //参数1：状态栏背景顔色（当setIsImmersive= true 时  要设置android.R.color.transparent）
                //参数2：状态栏字体颜色 是否为黑色
                .setStatusBar(0xffffffff, true)
                .setReturnStyle("ideal_signout", 30, 30, 20, ImageView.ScaleType.CENTER_CROP)
                //导航栏背景色
                .setNavColor(0x00335F5F)
                //导航栏 标题内容
                .setNavText("测试")
                .setNavHeight(45)
                //标题X轴偏移量 0居中
                .setNavTextOffsetX(0)
                //导航栏字体大小
                .setNavTextSize(17, false)
                //导航啦标题字体
                .setNavTextTypeface(Typeface.DEFAULT)
                //导航栏字体颜色
                .setNavTextColor(0xff000000)
                //logo样式 0居中 ,如果不设置logo 第一个参数值为 null
                .setLogoStyle("logo_ic", 144, 40, 110, 0, 0, ImageView.ScaleType.CENTER)
                //认证服务文本 参数一：移动运营商 参数二：电信运营商 参数三：联通运营商
                .setSloganText("移动认证服务", "天翼认证服务", "联通认证服务")
                .setSloganView(0xff2F2F2F, 10, 0, 230, false)
                //认证服务字体
                .setSloganTextTypeface(Typeface.MONOSPACE)
                //手机号颜色
                .setNumberColor(0xff2F2F2F)
                //手机号字体大小、粗细
                .setNumberSize(18)
                //号码栏X偏移量
                .setNumberOffsetX(0)
                //号码掩码字体是否加粗
                .setNumberThickness(true)
                //相对于状态栏y轴偏移量
                .setNumFieldOffsetY(190)
                //一键登录按钮背景
                .setLogBtnImgPath("new_ideal_login_btn_bg")
                //一键登录文本内容、文本字体颜色、文本字体大小、文本字体粗细
                .setLogBtnText("一键登录", 0xffffffff, 16, false)
                //相对于状态栏顶部登录按钮Y偏移量
                .setLogBtnOffsetY(251)
                //距离手机屏幕左右间距
                .setLogBtnMarginLeftRight(24, 24)
                //一键登录按钮宽高
                .setLogBtnWeightHeight(40).setSwitchStyle("----其他方式登录----", 0xff2F2F2F, 14, 310, 0)
                //切换按钮字体样式
                .setSwitchTextTypeface(Typeface.SANS_SERIF)
                //选中、非选中 宽、高
                .setCheckBoxImgPath("checked", "uncheck", 20, 20)
                //协议checkBox是否选中
                .setPrivacyStateSelect(false)
                //协议勾选框相对于协议文本位置 0居上 1居中
                .setCheckBoxLocation(0)
                //协议名称是否加书名号
                .setPrivacyBookSymbol(true)
                //协议前缀
                .setPrivacyTextBefore("登录即同意")
                //自定义协议1
                .setPrivacyTextAndUrl1(" 用户服务协议", "https://www.ctyun.cn/?track=source_baidubrand-medium_cpt-content_se899252")
                //自定义协议2
                .setPrivacyTextAndUrl2(" 隐私政策", "https://www.ctyun.cn/?track=source_baidubrand-medium_cpt-content_se899252")
                //自定义协议3
                .setPrivacyTextAndUrl3(" 政策3222 ", "https://www.ctyun.cn/?track=source_baidubrand-medium_cpt-content_se899252")
                //自定义协议4
                .setPrivacyTextAndUrl4(null, null)
                //协议条款后缀
                .setPrivacyTextAfter("并授权本应用获取手机号码")
                //协议条款连接语：x和x与y
                .setPrivacySplit("", "和")
                //设置隐私条款的字体大小，文本颜色，是否居中。协议标题和其他文案可以分开设置文本颜色
                .setPrivacyText(10, 0xff2F2F2F, 0xffDE0629)
                //设置协议距离屏幕左右边距
                .setPrivacyMargin(20, 20)
                //设置协议距离底部y轴距离 如不设置Y_B 填值为0
                .setPrivacyOffsetY_B(10)
                //设置协议距离顶部y轴距离如不设置Y  填值为0
                .setPrivacyOffsetY(0)
                //参数1，授权页的进场动画，参数2 授权页的退出动画
                .setPageActAnim("in_activity_new", "out_activity_new")
                //协议web的标题栏的字体颜色，字体大小
                .setWebNavStyle(0xff2F2F2F, 17)
                //实现二次弹窗功能
//                .setAuthLoginListener(new AuthLoginListener() {
//                    @Override
//                    public void onLoginListener(Context context, AuthLoginBtCallBack authLoginBtCallBack, Map<String, String> map) {
//                        String text = map.get("title");
//                        String url = map.get("url");
//                        showAlertDialog(context, authLoginBtCallBack,text);
//                        Log.i(TAG, "未勾选：" + text + "url:" + url);
//                    }
//                })
                .setAuthThemListener(new AuthThemListener() {
                    /**
                     * 未勾选协议回调
                     * */
                    @Override
                    public void onUnCheckedState(Context context) {
                        Toast.makeText(context, "请同意服务条款", Toast.LENGTH_SHORT).show();
                    }

                    /**
                     * 勾选框监听
                     * */
                    @Override
                    public void onCheckedStateChange(Context context, Boolean aBoolean) {
//                        Toast.makeText(context, aBoolean + "全屏勾选", Toast.LENGTH_SHORT).show();
                        Log.i(TAG, "全屏勾选:" + aBoolean);

                    }

                    /**
                     * 添加自定义View
                     * */
                    @Override
                    public void onAddCustomLayout(Context context, RelativeLayout relativeLayout) {
                        addCustomView(context, relativeLayout);
                    }

                    /**
                     * 其他登录方式
                     * */
                    @Override
                    public void onOtherLogin(Context context) {
                        Toast.makeText(context, "点击了其它登录", Toast.LENGTH_SHORT).show();
                    }

                    /**
                     * 关闭按钮点击回调
                     * */
                    @Override
                    public void onReturnClick(Context context) {
                        IdealSplash.quitAuthPage(context);
                    }

                    // 登录按钮点击回调 勾选框勾上时
                    @Override
                    public void setLogBtnClickListener(Context context) {
//                        alertDialog = new AlertDialog.Builder(context).create();
//                        alertDialog.setCancelable(false);
//                        alertDialog.setCanceledOnTouchOutside(false);
//                        alertDialog.setOnKeyListener(new DialogInterface.OnKeyListener() {
//                            @Override
//                            public boolean onKey(DialogInterface dialog, int keyCode, KeyEvent event) {
//                                if (event.getAction() == KeyEvent.ACTION_UP) {
//                                    dialog.dismiss();
//                                    alertDialog = null;
//                                }
//                                return keyCode == KeyEvent.KEYCODE_BACK;
//                            }
//                        });
//                        alertDialog.show();
//                        alertDialog.setContentView(LayoutInflater.from(context).inflate(R.layout.loading_alert, null));
                    }

                });
        return builder.build();
    }

    //弹框
    private OnenessAuthThemeDialogConfig onenessDialogConfig() {
        OnenessAuthThemeDialogConfig.Builder builder = new OnenessAuthThemeDialogConfig.Builder()
                .setAuthBGImgPath("dialog_bg")//样式背景
//                .setAuthBGImage("bg")//图片背景
//                .setAuthBGImgRadius(30)//图片背景圆角
                //设置状态栏的颜色，文字颜色是否为白色
                .setStatusBar(0xffffffff, true)
                //导航栏 标题内容（默认居中）
                .setNavText("标题")
                //导航栏背景色
                .setNavColor(0x00DE0629).setNavHeight(45)
                //标题X轴偏移量 0居中
                .setNavTextOffsetX(0)
                //导航栏字体颜色
                .setNavTextColor(0xff000000)
                //导航栏字体大小
                .setNavTextSize(17, false)
                //导航栏标题字体
                .setNavTextTypeface(Typeface.DEFAULT)
                //logo样式
                .setLogoStyle("logo_ic", 144, 40, 50, 0, 0, ImageView.ScaleType.CENTER)
                //认证服务
                .setSloganView(0xff2F2F2F, 10, 0, 130, false)
                //认证服务文本 参数一：移动运营商 参数二：电信运营商 参数三：联通运营商(备注：不可不设置)
                .setSloganText("移动认证服务", "电信认证服务", "联通认证服务")
                //认证服务字体
                .setSloganTextTypeface(Typeface.MONOSPACE)
                //手机号颜色
                .setNumberColor(0xff2F2F2F)
                //手机号字体大小
                .setNumberSize(25)
                //号码掩码字体是否加粗
                .setNumberThickness(true)
                //号码栏X偏移量0居中
                .setNumberOffsetX(0)
                //相对于状态栏y轴偏移量
                .setNumFieldOffsetY(95)
                //一键登录按钮背景
                .setLogBtnImgPath("new_ideal_login_btn_bg")
                //一键登录文本内容、文本字体颜色、文本字体大小、文本字体粗细
                .setLogBtnText("一键登录", 0xffffffff, 16, false)
                //相对于状态栏顶部登录按钮Y偏移量
                .setLogBtnOffsetY(157)
                //一键登录按钮宽高
                .setLogBtnWeightHeight(40)
                //距离手机屏幕左右间距
                .setLogBtnMarginLeftRight(30, 30).setSwitchStyle("----其他方式登录----", 0xff2F2F2F, 14, 210, 0).setSwitchTextTypeface(Typeface.SANS_SERIF)
                //选中、非选中 宽、高
                .setCheckBoxImgPath("checked", "uncheck", 20, 20)
                //协议checkBox是否选中
                .setPrivacyStateSelect(false)
                //协议勾选框相对于协议文本位置 0居上 1居中
                .setCheckBoxLocation(0)
                //协议名称是否加书名号
                .setPrivacyBookSymbol(true)
                //协议前缀
                .setPrivacyTextBefore("登录即同意")
                //自定义协议1
                .setPrivacyTextAndUrl1("用户服务协议", "https://www.ctyun.cn/?track=source_baidubrand-medium_cpt-content_se899252")
                //自定义协议2
                .setPrivacyTextAndUrl2("隐私政策", "https://www.ctyun.cn/?track=source_baidubrand-medium_cpt-content_se899252").setPrivacyTextAndUrl3("协议3", "https://www.ctyun.cn/?track=source_baidubrand-medium_cpt-content_se899252")
//                .setPrivacyTextAndUrl4(null, null)
                //协议条款后缀
                .setPrivacyTextAfter("并授权本应用获取手机号码")
                //协议条款连接语：x和x与y
                .setPrivacySplit(",", "和")
                //设置隐私条款的字体大小，文本颜色，是否居中。协议标题和其他文案可以分开设置文本颜色
                .setPrivacyText(10, 0xff2F2F2F, 0xffDE0629)
                //设置协议距离屏幕左右边距
                .setPrivacyMargin(20, 20)
                //设置协议距离底部y轴距离
                .setPrivacyOffsetY_B(10).setPrivacyOffsetY(0)
                //协议web的标题栏字体颜色，字体大小
                .setWebNavStyle(0xff2F2F2F, 17);
        // 是否底部弹窗
        if (isBottomDialog) {
            builder.setIsBottom(true);
            //弹窗大小 底部弹窗也需设置此值
            builder.setPageWindowMode(capabilities.getScreenWidth(context), 300);
            //导航栏返回按钮样式
            builder.setReturnStyle("ideal_signout", 30, 30, capabilities.getScreenWidth(context) - 60, ImageView.ScaleType.CENTER);
        } else {
            builder.setIsBottom(false);//居中
            //弹窗大小
            builder.setPageWindowMode(300, 300);
            builder.setReturnStyle("ideal_signout", 30, 30, 300 - 60, ImageView.ScaleType.CENTER);
        }
        builder.setAuthThemListener(new AuthThemListener() {
            /**
             * 未勾选协议框点击回调
             * */
            @Override
            public void onUnCheckedState(Context context) {
                Toast.makeText(context, "请同意服务条款", Toast.LENGTH_SHORT).show();
            }

            /**
             * 勾选框监听
             * */
            @Override
            public void onCheckedStateChange(Context context, Boolean aBoolean) {
//                        Toast.makeText(context, aBoolean + "弹窗勾选", Toast.LENGTH_SHORT).show();
            }

            /**
             * 添加自定义View
             *
             * */
            @Override
            public void onAddCustomLayout(Context context, RelativeLayout relativeLayout) {
//                addCustomViewDialog(context, relativeLayout);
//                addCustomView2(context, relativeLayout);
            }

            /**
             * 其他登录方式点击回调
             * */
            @Override
            public void onOtherLogin(Context context) {
//                Toast.makeText(context, "点击了其它登录", Toast.LENGTH_SHORT).show();
            }

            /**
             * 关闭按钮点击回调
             * */
            @Override
            public void onReturnClick(Context context) {
                IdealSplash.quitAuthPage(context);
            }

            //登录按钮点击回调 勾选框勾上时
            @Override
            public void setLogBtnClickListener(Context context) {
//                Log.i(TAG, "点1次");
            }

        });
        return builder.build();
    }

    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.login_page:
                isDialog = false;
                preLogin(context, customCallback, 5);
                break;
            case R.id.login_dialog_page:
                isDialog = true;
                isBottomDialog = false;//demo需要
                preLogin(context, customCallback, 5);
                break;
            case R.id.login_bottom_dialog_page:
                isDialog = true;
                isBottomDialog = true;//demo需要
                preLogin(context, customCallback, 5);
                break;
            case R.id.local_calibration:
                //本机号码校验
                //初始化：
                startActivity(new Intent(context, LocalCalibration.class));
                break;
        }
    }

    //初始化回调
    private void initCallBack() {
        initCallOnClick.getInstance().setOnclickCallBack(new initCallBack() {
            @Override
            public void initCallBack(String response) {
                Log.i(TAG, "初始化结果" + response);
                if (response != null) {
                    try {
                        JSONObject responseObj = new JSONObject(response);
                        String userId = responseObj.optString("userId");
                        String code = responseObj.optString("code");
                        String msg = responseObj.optString("msg");
                        String operatorType = responseObj.optString("operatorType");
                        Handler handler = new Handler(Looper.getMainLooper());
                        handler.post(new Runnable() {
                            @Override
                            public void run() {
                                Toast.makeText(context, "初始化结果:" + response, Toast.LENGTH_SHORT).show();
                            }
                        });
                        initUserId = userId;
                        if (!code.equals("200")) {
                            //初始化不成功
                            Intent intent = new Intent(context, VerifyResultActivity.class);
                            intent.putExtra("resCode", code);
                            intent.putExtra("resMsg", response);
                            intent.putExtra("resType", "3");
                            startActivity(intent);
                        } else if (code.equals("200")) {
                            //预取号
                        }
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }
                }
            }
        });
    }

    //自定义view
    private void addCustomView(final Context context, RelativeLayout parentView) {

        RelativeLayout containerView = parentView;
        LayoutInflater inflater1 = LayoutInflater.from(context);
        //其他登录方式
        RelativeLayout relativeLayout = (RelativeLayout) inflater1.inflate(R.layout.relative_item_view, null);

        RelativeLayout.LayoutParams layoutParamsOther = new RelativeLayout.LayoutParams(RelativeLayout.LayoutParams.WRAP_CONTENT, RelativeLayout.LayoutParams.WRAP_CONTENT);
        layoutParamsOther.setMargins(0, capabilities.dip2px(context, 360), 0, 0);
        layoutParamsOther.addRule(RelativeLayout.CENTER_HORIZONTAL);
        relativeLayout.setLayoutParams(layoutParamsOther);

        containerView.addView(relativeLayout);

        ImageView weixin = relativeLayout.findViewById(R.id.weixin);
        ImageView qq = relativeLayout.findViewById(R.id.qq);
        ImageView weibo = relativeLayout.findViewById(R.id.weibo);
        weixin.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Toast.makeText(context, "微信登录", Toast.LENGTH_SHORT).show();
            }
        });
        qq.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Toast.makeText(context, "QQ登录", Toast.LENGTH_SHORT).show();
            }
        });
        weibo.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Toast.makeText(context, "微博登录", Toast.LENGTH_SHORT).show();
            }
        });
    }

    private void showAlertDialog(Context mcontext, AuthLoginBtCallBack authLoginCallBack,String txt) {
        AlertDialog.Builder builder = new AlertDialog.Builder(mcontext,R.style.MyAlertDialogStyle);
        LayoutInflater inflater = getLayoutInflater();
        View dialogView = inflater.inflate(R.layout.custom_alert_dialog, null);
        builder.setView(dialogView);

        TextView textView = dialogView.findViewById(R.id.textView);
        TextView cancel = dialogView.findViewById(R.id.cancel);
        TextView login = dialogView.findViewById(R.id.login);
        textView.setText("未勾选协议，是否继登录？");


        AlertDialog alertDialog = builder.create();
        alertDialog.show();
        cancel.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                alertDialog.dismiss();
            }
        });
        login.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //是否继续登录
                authLoginCallBack.onAuthLoginCallBack(true);
                alertDialog.dismiss();
            }
        });
    }
}