package com.example.myapplication;

import androidx.appcompat.app.AppCompatActivity;

import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.util.Log;
import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;
import org.json.JSONException;
import org.json.JSONObject;

public class VerifyResultActivity extends AppCompatActivity {
    private ImageView res_img;
    private TextView res_tv;
    private TextView hint_tv;
    private TextView result_tv;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        capabilities.StatusBar(VerifyResultActivity.this);

        setContentView(R.layout.activity_verify_result);
        res_img = findViewById(R.id.res_img);
        res_tv = findViewById(R.id.res_tv);
        hint_tv = findViewById(R.id.hint_tv);
        result_tv = findViewById(R.id.result_tv);

        Intent intent = getIntent();
        res = intent.getStringExtra("resCode");
        resMsg = intent.getStringExtra("resMsg");
        type = intent.getStringExtra("resType");
        if (type.equals("1")) {
            if (res.equals("200")) {
                res_img.setBackgroundResource(R.mipmap.succeed_ic);
                res_tv.setText("登录成功！");
                hint_tv.setText("完成");
                result_tv.setVisibility(View.VISIBLE);
                result_tv.setText(resMsg);
                try {
                    JSONObject object = new JSONObject(resMsg);
                    JSONObject num =object.getJSONObject("data");
                    String number = num.getString("mobile");
                    SharedPreferences sp2 = PreferenceManager.getDefaultSharedPreferences(this);
                    SharedPreferences.Editor editor = sp2.edit();
                    editor.putString("number", number);
                    editor.apply();
                } catch (JSONException e) {
                    e.printStackTrace();
                }
            } else {
                res_img.setBackgroundResource(R.mipmap.fail_ic);
                res_tv.setText("登录失败！");
                hint_tv.setText("重新登录");
                result_tv.setVisibility(View.VISIBLE);
                result_tv.setText(resMsg);
            }
        } else if(type.equals("2")){
            if (res.equals("200")) {
                try {
                    JSONObject responseObj = new JSONObject(resMsg);
                    JSONObject dataObj = responseObj.getJSONObject("data");
                    String verifyMobile = dataObj.optString("verifyMobile");
                    if (verifyMobile.equals("0")) {
                        res_img.setBackgroundResource(R.mipmap.succeed_ic);
                        res_tv.setText("认证成功！");
                        hint_tv.setText("完成");
                        result_tv.setVisibility(View.GONE);
                    } else {
                        res_img.setBackgroundResource(R.mipmap.fail_ic);
                        res_tv.setText("认证失败！");
                        hint_tv.setText("重新认证");
                        result_tv.setVisibility(View.VISIBLE);
                        result_tv.setText(resMsg);
                    }
                } catch (JSONException e) {
                    e.printStackTrace();
                }
            } else {
                res_img.setBackgroundResource(R.mipmap.fail_ic);
                res_tv.setText("认证失败！");
                hint_tv.setText("重新认证");
                result_tv.setVisibility(View.VISIBLE);
                result_tv.setText(resMsg);
            }
        }else if(type.equals("3")){
            res_img.setBackgroundResource(R.mipmap.fail_ic);
            res_tv.setText("初始化失败！");
            hint_tv.setText("请重新初始化！");
            result_tv.setVisibility(View.VISIBLE);
            result_tv.setText(resMsg);
        }
        hint_tv.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();
            }
        });
    }

    private String res;
    private String resMsg;
    private String type;
}